/*
 * @(#)ConnectedTextTool.java 5.1
 *
 */

package CH.ifa.draw.figures;

import java.awt.*;
import java.awt.event.MouseEvent;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;

/**
 * Tool to create new or edit existing text figures.
 * A new text figure is connected with the clicked figure.
 *
 * @see TextHolder
 */
public  class ConnectedTextTool extends TextTool {

    boolean     fConnected = false;

    public ConnectedTextTool(DrawingEditor editor, TextFigure prototype) {
        super(editor, prototype);
    }

    /**
     * If the pressed figure is a TextHolder it can be edited otherwise
     * a new text figure is created.
     */
    public void mouseDown(MouseEvent e, int x, int y) {
        super.mouseDown(e, x, y);

        Figure pressedFigure =  drawing().findFigureInside(x, y);

        ChildFigure child = (ChildFigure)createdFigure();
        if (!fConnected && child != null
	    && pressedFigure instanceof ParentFigure
	    && child.setParent((ParentFigure)pressedFigure)) {
            fConnected = true;
        }
    }

    /**
     * If the pressed figure is a TextHolder it can be edited otherwise
     * a new text figure is created.
     */
    public void activate() {
      super.activate();
      fConnected = false;
    }
}

