/*
 * @(#)SelectAllCommand.java 5.1
 *
 */

package CH.ifa.draw.figures;

import java.util.*;
import CH.ifa.draw.util.Command;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;

/**
 * Command to select all Figures of the current drawing.
 *
 * @see SelectionTool
 */
public  class SelectAllCommand extends Command {

    protected DrawingEditor fEditor;

   /**
    * Constructs a select all command.
    * @param name the command name
    * @param view the target editor
    */
    public SelectAllCommand(String name, DrawingEditor editor) {
        super(name);
        fEditor = editor;
    }

    public void execute() {
        DrawingView view = fEditor.view();
        Drawing drawing = view.drawing();
        FigureEnumeration figenum=drawing.figures();
        while (figenum.hasMoreElements()) {
                view.addToSelection(figenum.nextFigure());
        }
        view.checkDamage();
    }

}


