package de.renew.formalism.fs;

import java.util.Vector;
import fs.*;
import de.renew.unify.*;
import collections.*;

class FSUnifier {
  Variable result;
  private Vector variables= new Vector();
  private FeatureStructure current;
  private int open=0;

  FSUnifier(FeatureStructure template, Vector paths, StateRecorder recorder)
    throws Impossible
  {
    result=new Variable();
    current=template;

    // Create listeners.
    for (int i=0; i<paths.size(); i++) {
      Variable variable = new Variable();
      variables.addElement(variable);
      setupListener(variable,(String)paths.elementAt(i),recorder);
      open++;
    }
  }

  Variable getVariable(int i) {
    return (Variable)variables.elementAt(i);
  }

  void setupListener(final Variable variable, final String path,
    StateRecorder recorder) throws Impossible
  {
    variable.addListener(new Notifiable() {
      public void boundNotify(StateRecorder irecorder) throws Impossible {
	Object val=variable.getValue();
	final FeatureStructure oldCurrent=current;
	irecorder.record(new StateRestorer() {
	  public void restore() {
	    current=oldCurrent;
	    open++;
	  }
	});
	open--;
	Node fs;
	if (val instanceof FeatureStructure) {
	  fs=((FeatureStructure)val).getRoot();
        } else if (val instanceof Class) {
           fs=new FSNode(new ConjunctiveType(JavaConcept.getJavaConcept((Class)val)));
	} else {
          fs=new JavaObjectFS(val);
	}
	try {
	  current=new FeatureStructure(EquivRelation.unify(current.getRoot(),path,fs));
	} catch (UnificationFailure uff) {
	  throw new Impossible();
	}
	if (open==0) {
	  Unify.unify(result,current,irecorder);
	}
      }
    },recorder);
  }
}
