package de.renew.formalism.fs;

import collections.*;
import de.renew.unify.*;
import de.renew.simulator.*;
import fs.*;
import java.util.Vector;

public class FSUnifyExpression implements Expression {
  FeatureStructure template;
  Vector paths;
  Vector exprs;

  public FSUnifyExpression(FeatureStructure template, Vector paths, Vector exprs) {
    this.template=template;
    this.paths=paths;
    this.exprs=exprs;
  }

  public boolean isInvertible() {
    return false;
  }

  public Object startEvaluation(VariableMapper mapper, StateRecorder recorder, 
    CalculationChecker checker) throws Impossible
  {
    if (exprs.size()>0) {
      FSUnifier unifier=new FSUnifier(template,paths,recorder);
      
      for (int i=0; i<exprs.size(); i++) {
        Expression expr=(Expression)exprs.elementAt(i);
        Unify.unify(unifier.getVariable(i),
	  expr.startEvaluation(mapper,recorder,checker),recorder);
      }
      
      return unifier.result.getValue();
    } else {
      return template;
    }
  }

  public Object registerCalculation(VariableMapper mapper,
    StateRecorder recorder, CalculationChecker checker) throws Impossible
  {
    throw new Impossible("No FeatureStructure composition in actions.");
  }
}

