package de.renew.function;

import de.renew.unify.*;

// A cast function will attempt a cast whenever possible.
// If primitive values are casted, this might result in loss of
// precision.

public class CastFunction implements de.renew.unify.Function {
  Class clazz;

  public CastFunction(Class clazz) {
    this.clazz=clazz;
  }

  public Object function(Object arg) throws Impossible {
    if (clazz.isPrimitive()) {
      if (arg instanceof Value) {
	Object value=((Value)arg).value;
	if (value instanceof Boolean) {
	  if (clazz==Boolean.TYPE) {
	    return arg;
	  }
	} else {
	  Number number;
	  if (value instanceof Character) {
	    char charVal=((Character)value).charValue();
	    number=new Integer((int)charVal);
	  } else {
	    number=(Number)value;
	  }
	  if (clazz==Character.TYPE) {
	    return new Value(new Character((char)number.intValue()));
	  } else if (clazz==Byte.TYPE) {
	    return new Value(new Byte(number.byteValue()));
	  } else if (clazz==Short.TYPE) {
	    return new Value(new Short(number.shortValue()));
	  } else if (clazz==Integer.TYPE) {
	    return new Value(new Integer(number.intValue()));
	  } else if (clazz==Long.TYPE) {
	    return new Value(new Long(number.longValue()));
	  } else if (clazz==Float.TYPE) {
	    return new Value(new Float(number.floatValue()));
	  } else if (clazz==Double.TYPE) {
	    return new Value(new Double(number.doubleValue()));
	  }  
	}
      }
    } else {
      if (arg==null || clazz.isInstance(arg)) {
	return arg;
      }
    }
    throw new Impossible();
  }
}
