package de.renew.function;

import de.renew.unify.*;

public class InstanceofFunction implements de.renew.unify.Function {
  private Class clazz;
  private boolean allowsNull;

  public InstanceofFunction(Class clazz, boolean allowsNull) {
    if (clazz==null) {
      throw new NullPointerException();
    }
    this.clazz=clazz;
    this.allowsNull=allowsNull;
  }

  public InstanceofFunction(Class clazz) {
    this(clazz,false);
  }

  public InstanceofFunction(String name) {
    try {
      clazz=Class.forName(name);
    }
    catch (Exception e) {
      throw new RuntimeException(e.toString());
    }
  }

  Class objectify(Class clazz) {
    if (clazz==Boolean.TYPE) {
      return Boolean.class;
    } else if (clazz==Character.TYPE) {
      return Character.class;
    } else if (clazz==Byte.TYPE) {
      return Byte.class;
    } else if (clazz==Short.TYPE) {
      return Short.class;
    } else if (clazz==Integer.TYPE) {
      return Integer.class;
    } else if (clazz==Long.TYPE) {
      return Long.class;
    } else if (clazz==Float.TYPE) {
      return Float.class;
    } else if (clazz==Double.TYPE) {
      return Double.class;
    } 
    return clazz;
  }
  
  public Object function(Object param) throws Impossible {
    boolean result;
    if (param instanceof Value) {
      if (clazz.isPrimitive()) {
	result=objectify(clazz).isInstance(((Value)param).value);
      } else {
	result=false;
      }
    } else if (param==null) {
      result=allowsNull;
    } else  {
      result=clazz.isInstance(param);
    }
    return new Value(new Boolean(result));
  }
}
