package de.renew.function;

import de.renew.unify.*;
import java.lang.reflect.Method;

public class MethodFunction implements de.renew.unify.Function {
  Object method;
  public MethodFunction(String method) {
    this.method=method;
  }
  public MethodFunction(Method method) {
    this.method=method;
  }

  public Object function(Object param) throws Impossible {
    Tuple tuple=(Tuple)param;
    if (tuple.getArity()!=2) {
      throw new Impossible();
    }
    Object obj=tuple.getComponent(0);
    Tuple args=(Tuple)tuple.getComponent(1);

    Object[] paramArr=new Object[args.getArity()];
    for (int i=0;i<paramArr.length;i++) {
      paramArr[i]=args.getComponent(i);
    }

    try {
      if (method instanceof String) {
	return Executor.executeMethod(obj.getClass(),obj,(String)method,
          paramArr);
      } else {
	return Executor.executeMethod((Method)method,obj,paramArr);
      }
    }
    catch (Exception e) {
      //e.printStackTrace();
      //if (e instanceof java.lang.reflect.InvocationTargetException) {
      //  ((java.lang.reflect.InvocationTargetException)e)
      //    .getTargetException().printStackTrace();
      //}
      throw new Impossible(
        "An exception occured during a method call.");
    }
  }
}

