package de.renew.function;

import de.renew.unify.*;
import java.lang.reflect.*;

public class StaticMethodFunction implements de.renew.unify.Function {
  Object method;
  Class clazz;

  public StaticMethodFunction(String method, Class clazz) {
    this.method=method;
    this.clazz=clazz;
  }

  public StaticMethodFunction(Method method) {
    if ((method.getModifiers() & Modifier.STATIC)==0) {
      throw new RuntimeException("Method expected to be static.");
    }
    this.method=method;
    this.clazz=null;
  }

  public Object function(Object param) throws Impossible {
    Tuple args=(Tuple)param;

    Object[] paramArr=new Object[args.getArity()];
    for (int i=0;i<paramArr.length;i++) {
      paramArr[i]=args.getComponent(i);
    }

    try {
      if (method instanceof String) {
	return Executor.executeMethod(clazz,null,(String)method,paramArr);
      } else {
	return Executor.executeMethod((Method)method,null,paramArr);
      }
    }
    catch (Exception e) {
      //e.printStackTrace();
      throw new Impossible("An exception occured during a method call.");
    }
  }
}
