/*
 * @(#)ArcConnectionHandle.java 5.1
 *
 */

package de.renew.gui;

import java.awt.*;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.util.Geom;

/**
 * A handle to connect Places to Transitions and vice versa.
 *
 * @see ConnectionFigure
 */

public  class ArcConnectionHandle extends ConnectionHandle {

    /**
     * Constructs a handle for the given owner
     */
    public ArcConnectionHandle(Figure owner) {
        super(owner, RelativeLocator.center(), ArcConnection.NormalArc);
    }

    /**
     * Connects the figures if the mouse is released over another
     * Transition/Place figure;
     * otherwise, the respective figure is created!
     */
    public void invokeEnd(int x, int y, int anchorX, int anchorY, DrawingView view) {
        Connector target = findConnectionTarget(x, y, view.drawing());
        if (target == null) {
           Figure owner = owner();
           if (owner.findFigureInside(x,y)==null) {
               Figure endFigure;
               Dimension d;
               if (owner instanceof PlaceFigure) {
                  //System.out.println("Creating Transition!");
                  endFigure=new TransitionFigure();
                  d = TransitionFigure.defaultDimension();
               } else {
                  //System.out.println("Creating Place!");
                  endFigure=new PlaceFigure();
                  d = PlaceFigure.defaultDimension();
               }
               int w2=d.width/2, h2=d.height/2;
               endFigure.displayBox(new Point(x-w2,y-h2),
		 new Point(x-w2+d.width,y-h2+d.height));
               view.drawing().add(endFigure);
           }
        }
        super.invokeEnd(x,y,anchorX,anchorY,view);
    }

}
