package de.renew.gui;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import de.renew.simulator.*;
import collections.*;

public class CardBagFigure extends TextFigure {

    private PlaceInstance placeInstance;
    private int cacheMult = -1;
    private int cacheTestMult = -1;

    public CardBagFigure(PlaceInstance pi) {
       super();
       setReadOnly(true);
       placeInstance = pi;
       update();
    }

  public boolean update() {
    placeInstance.lock.lock();
    int newMult = placeInstance.getTokens().getSize();
    int newTestMult = placeInstance.getNumberOfTestedTokens();
    placeInstance.lock.unlock();

    if ((newMult!=cacheMult) || (newTestMult!=cacheTestMult)) {
       cacheMult = newMult;
       cacheTestMult = newTestMult;

       if (newTestMult > 0) {
	 if (newMult>0) {
           setText(newMult+"("+newTestMult+")");
	 } else {
	   setText("("+newTestMult+")");
	 }
       } else if (newMult > 0)
	 setText(String.valueOf(newMult));
       else
	 setText(" ");

       if (listener() != null)
          listener().figureRequestUpdate(new FigureChangeEvent(this));

       return true;
    } else {
       return false;
    }
  }

  public boolean inspect(DrawingView view, boolean alternate) {
    if (alternate) {
       return false;
    } else {
       ((CPNApplication)view.editor()).openTokenBagDrawing(placeInstance);
       return true;
    }
  }

}

