/*
 * @(#)DeclarationFigure.java 5.1
 *
 */

package de.renew.gui;

import java.awt.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import de.renew.simulator.*;
import de.renew.shadow.*;

public class DeclarationFigure extends CPNTextFigure
                               implements ShadowHolder
{
  /*
   * Serialization support.
   */
  private static final long serialVersionUID = -7877776241236946511L;
  private int declFigureSerializedDataVersion = 1;
  
  public DeclarationFigure() {
    super(INSCRIPTION);
  }
  
  private ShadowDeclarationNode shadow = null;

  public void release() {
    super.release();
    if (shadow!=null)
      shadow.discard();
  }  

  public ShadowNetElement buildShadow(ShadowNet net) {
      if (shadow!=null)
         shadow.discard();
      shadow = new ShadowDeclarationNode(net,getText());
      shadow.context = this;
      // No longer calling the syntax check. This is done
      // after editing the text and in no other place should a
      // syntax check occur.
      return shadow;
  }

  public ShadowNetElement getShadow() { return shadow; }

  public boolean canBeParent(ParentFigure parent) {
    return parent == null;
  }

 }
