package de.renew.gui;

import java.util.*;
import de.renew.shadow.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.TextFigure;

public class FigureException extends Exception {
  // the following should all be final, but compiler bug...
  public int line;
  public int column;
  public TextFigure textErrorFigure;

  public CPNDrawing errorDrawing;
  public final Vector errorFigures=new Vector();

  public FigureException(SyntaxException e)
  {
    super(e.getMessage());
    line=e.line;
    column=e.column;

    TextFigure textErrorFigure=null;
    if (!e.errorObjects.isEmpty()) {
      // Determine the offending drawing.
      errorDrawing=CPNDrawing.findDrawing(e.errorObjects.elementAt(0));
      if (errorDrawing != null) {
        boolean errorFound=false;
        Enumeration errorObjects=e.errorObjects.elements();
        while (errorObjects.hasMoreElements()) {
	  Object errorObject=errorObjects.nextElement();
	  Figure errorFigure=null;
	  if (errorObject instanceof ShadowNetElement) {
                errorFigure=(Figure)((ShadowNetElement)errorObject).context;
          }
	  if (errorFigure!=null) {
	    if (errorFound) {
	      textErrorFigure = null; // only invoke text editor for single error objects!
	    } else {
	      errorFound=true;
	      if (e.line > 0 && e.column > 0 &&
		  errorFigure instanceof TextFigure &&
		  ((TextFigure)errorFigure).acceptsTyping()) {
	        textErrorFigure = (TextFigure)errorFigure;
	      }
	    }
	    errorFigures.addElement(errorFigure);
	  }
	}
      }
    } else {
      errorDrawing=null;
    }
    this.textErrorFigure=textErrorFigure;
  }

  public FigureException(SyntaxException e, CPNDrawing drawing, TextFigure textErrorFigure) {
    super(e.getMessage());
    line=e.line;
    column=e.column;
    this.errorDrawing=drawing;
    this.textErrorFigure=textErrorFigure;
    errorFigures.addElement(textErrorFigure);
  }
}
