/*
 * @(#)PlaceFigure.java 5.1
 *
 */

package de.renew.gui;

import java.awt.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import de.renew.simulator.*;
import de.renew.shadow.*;

public class PlaceFigure extends EllipseFigure implements NodeFigure {
    /*
     * Serialization support.
     */
    private static final long serialVersionUID = -7878886241236946512L;
    private int transFigureSerializedDataVersion = 1;

    public PlaceFigure() {
        super();
    }

    public Vector handles() {
        Vector handles = super.handles();
        handles.addElement(new ArcConnectionHandle(this));
	return handles;
    }


  public boolean getTraceMode() {
    Object value=getAttribute("TraceMode");
    if (value instanceof Boolean) {
      return ((Boolean)value).booleanValue();
    }
    return true;
  }

  private ShadowPlace shadow = null;

  public void release() {
    super.release();
    if (shadow!=null)
      shadow.discard();
  }  

  public ShadowNetElement buildShadow(ShadowNet net) {
      if (shadow!=null)
         shadow.discard();
      shadow = new ShadowPlace(net);
      shadow.context = this;
      shadow.setTrace(getTraceMode());
      //System.err.println("place shadow for "+this+" created!");
      return shadow;
  }

  public ShadowNetElement getShadow() {
    return shadow;
  }

  public static Dimension defaultDimension() {
    return new Dimension(20,20);
  }

  public String getDefaultInscription() {
     return "[]";
  }

}

