package de.renew.gui;

import java.awt.*;
import java.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import de.renew.simulator.*;
import collections.*;

abstract public class SimpleCompositeFigure extends CompositeFigure {

    protected Rectangle fDisplayBox = new Rectangle(0,0,0,0);

/*
    public void draw(Graphics g) {
       g.setColor(Color.red);
       g.drawRect(fDisplayBox.x,fDisplayBox.y,fDisplayBox.width,fDisplayBox.height);
       super.draw(g);
    }
*/

    protected void basicMoveBy(int x, int y) {
	    fDisplayBox.translate(x, y);
	    super.basicMoveBy(x, y);
	}

    public void moveBy(int x, int y) {
        willChange();
        basicMoveBy(x, y);
        changed();
    }

    public Rectangle displayBox() {
        return new Rectangle(
            fDisplayBox.x,
            fDisplayBox.y,
            fDisplayBox.width,
            fDisplayBox.height);
    }

    public void basicDisplayBox(Point origin, Point corner) {
        fDisplayBox = new Rectangle(origin);
        fDisplayBox.add(corner);
        layout();
    }

    public Vector handles() {
        Vector handles = new Vector();
        handles.addElement(new NullHandle(this, RelativeLocator.northWest()));
        handles.addElement(new NullHandle(this, RelativeLocator.northEast()));
        handles.addElement(new NullHandle(this, RelativeLocator.southWest()));
        handles.addElement(new NullHandle(this, RelativeLocator.southEast()));
        return handles;
    }

    abstract protected void layout();

    abstract protected boolean needsLayout();

    public void update(FigureChangeEvent e) {
      if (needsLayout()) {
	willChange();
	layout();
	changed();
      }
    }

    public void figureChanged(FigureChangeEvent e) {
        update(e);
    }


    public void figureRemoved(FigureChangeEvent e) {
        update(e);
    }

    public boolean inspect(DrawingView view, boolean alternate) {
       Point click=view.lastClick();
       Figure inside = findFigureInside(click.x, click.y);
       if (inside != null && inside.inspect(view, alternate))
          return true;
        if (alternate) {
           return false; // don't use default alternate behaviour
        } else {
           return super.inspect(view,false);  // do use default normal behaviour
        }
    }

     public void setAttribute(String name, Object value) {
        Enumeration figenum = figures();
        while (figenum.hasMoreElements()) {
            ((Figure)figenum.nextElement()).setAttribute(name,value);
        }
     }

     public Object getAttribute(String name) {
        Enumeration figenum = figures();
        if (figenum.hasMoreElements()) {
            return ((Figure)figenum.nextElement()).getAttribute(name);
        }
        return null;
     }

}

