package de.renew.gui;

import java.util.*;
import CH.ifa.draw.standard.StandardDrawing;
import de.renew.simulator.*;

public class TokenBagDrawing extends StandardDrawing {

  private static Hashtable drawingsByInstance = new Hashtable();

  private PlaceInstance placeInstance=null;

  static TokenBagDrawing getTokenBagDrawing(PlaceInstance pi) {
    // forbid concurrent searches for instance drawings.
    synchronized (drawingsByInstance) {
      // find instance drawing:
      if (drawingsByInstance.containsKey(pi))
	return (TokenBagDrawing)drawingsByInstance.get(pi);
      else
	return new TokenBagDrawing(pi);
    }
  }

  private TokenBagDrawing(PlaceInstance pi) {
      this.placeInstance = pi;
      drawingsByInstance.put(pi,this);
      setName(placeInstance.toString());

      ExpandedTokenBagFigure etbf=new ExpandedTokenBagFigure(pi);
      etbf.toggleExpanded();
      add(etbf);
  }


  public void release() {
    if (placeInstance != null) {
      drawingsByInstance.remove(placeInstance);
      placeInstance = null;
    }
    super.release();
  }

   /**
     * Returns whether drawing has been modified since last save.
     */
    public boolean isModified() {
       return false;  // a TokenBagDrawing should not be saved!
    }

}

