package de.renew.gui;

import java.awt.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import de.renew.simulator.*;
import de.renew.unify.Tuple;
import fs.FeatureStructure;
import fs.FSFigure;

public class TokenFigure extends HorizontalCompositeFigure {

   final Object token;
//   private boolean expanded=true;

   public static Figure getTokenFigure(Object token)
   {
      if (token instanceof FeatureStructure) {
         return new FSFigure((FeatureStructure)token);
      } else if (token instanceof Tuple && ((Tuple)token).getArity() > 0) {
         return new TupleFigure((Tuple)token);
      } else {
         return new TextTokenFigure(token);
      }
   }

   public static String getMultString(int mult, boolean isTested) {
     StringBuffer output = new StringBuffer();

     if (isTested) {
       if (mult>0) {
	 output.append(String.valueOf(mult));
       }
       output.append("(1)'");
     } else if (mult > 1) {
       output.append(String.valueOf(mult));
       output.append("'");
     }
     
     return output.toString();
   }

   public TokenFigure(int mult, boolean isTested, Object token) {
      this.token = token;
      add(new TextFigure(getMultString(mult,isTested), true));
      add(getTokenFigure(token));
      layout();
   }

/*
   public boolean inspect(DrawingView view, boolean alternate) {
     if (alternate) {
       toggleExpanded();
       return true;
     } else {
        return super.inspect(view,alternate);
     }

   }

   public void toggleExpanded() {
      expanded=!expanded;
      layout();
   }
*/
}
