package de.renew.shadow;

public interface ShadowCompiler extends java.io.Serializable {
  // A shadow compiler must be serialisable.
  // Usually this is no problem.

  // Compile a net system and return a lookup that knows
  // about the compiled nets.
  public ShadowLookup compile(ShadowNetSystem netSystem)
    throws SyntaxException;
    
  // Return an array of names of special checks that are not
  // required during compilation, but can help to find
  // common mistakes in the models. getLintNames().length
  // gives the number of possible checks.
  public String[] getLintNames();  
  // Perform one special check. The numbering starts with 0.
  public void lint(int lintNr, ShadowNetSystem netSystem)
    throws SyntaxException;
    
  // Perform a syntax check for a string. The string is
  // parsed, if possible, in the context of a given
  // shadow net, so that declarations can be handled.
  public void checkDeclarationNode(String inscr)
    throws SyntaxException;
  public void checkArcInscription(String inscr, ShadowNet shadowNet)
    throws SyntaxException;
  public void checkTransitionInscription(String inscr, ShadowNet shadowNet)
    throws SyntaxException;
  public void checkPlaceInscription(String inscr, ShadowNet shadowNet)
    throws SyntaxException; 
}
