package de.renew.shadow;

import java.util.Hashtable;
import java.util.Enumeration;
import de.renew.simulator.*;

// I am simply a typesafe hash table to identify the
// compiled objects that arise from shadow objects.
//
// I do not any longer map arcs, because a single arc
// might be mapped to multiple arcs in the compiled net.
// And besides, nobody ever needed this feature.
//
// I no longer provide unique place and transition names.
// I am not sure why I ever did that, it's not my business.

public class ShadowLookup {
  private Hashtable netMap;
  private Hashtable placeMap;
  private Hashtable transitionMap;

  public ShadowLookup() {
    netMap=new Hashtable();
    placeMap=new Hashtable();
    transitionMap=new Hashtable();
  }

  public void setNet(String name, Net net) {
    netMap.put(name,net);
  }
  public Net getNet(String name) {
    return (Net)netMap.get(name);
  }
  public Enumeration allNetNames() {
    return netMap.keys();
  }

  public void set(ShadowPlace element, Place obj) {
    placeMap.put(element,obj);
  }
  public Place get(ShadowPlace element) {
    return (Place)placeMap.get(element);
  }
  public Enumeration allPlaces() {
    return placeMap.keys();
  }

  public void set(ShadowTransition element, Transition obj) {
    transitionMap.put(element,obj);
  }
  public Transition get(ShadowTransition element) {
    return (Transition)transitionMap.get(element);
  }
  public Enumeration allTransitions() {
    return transitionMap.keys();
  }
}
