package de.renew.shadow;

import collections.*;

public abstract class ShadowNetElement implements java.io.Serializable {
  // Not used by the shadow classes. May be used to
  // denote the origin of this shadow in an application
  // specific way. Will not be serialized, but that should 
  // not be a problem in the usual application domains.
  public transient Object context=null;

  // Every shadow net element is permanently associated to a shadow net.
  final ShadowNet shadowNet;

  ShadowNetElement(ShadowNet shadowNet) {
    this.shadowNet=shadowNet;
  }

  public ShadowNet getNet() {
    return shadowNet;
  }

  public abstract void discard();
}
