package de.renew.shadow;

import collections.*;

public abstract class ShadowNode extends ShadowInscribable {
  static final long serialVersionUID = 6077849783470486673L;

  private String name;
  private boolean trace;

  ShadowNode(ShadowNet shadowNet) {
    super(shadowNet);
    name=null;
    setTrace(true);
    
    // Register myself with the net.
    shadowNet.add(this);
  }

  public void discard() {
    shadowNet.remove(this);
  }

  public ShadowNet getNet() {
    return shadowNet;
  }

  public void setName(String name) {
    this.name=name;
  }

  public String getName() {
    return name;
  }

  public void setTrace(boolean trace) {
    if (this.trace!=trace) {
      this.trace=trace;
    }
  }

  public boolean getTrace() {
    return trace;
  }
}
