package de.renew.simulator;

import collections.*;

public class Arc implements OccurrableInscription {
  public static final int in=-1;       // input arc
  public static final int test=0;      // test arc
  public static final int out=1;       // output arc
  public static final int both=2;      // double arc that reserves the token
  public static final int fastBoth=3;  // double arc that releases the token
                                       // early during the firing
  public static final int fastTest=4;  // test arc that releases the token
                                       // early during the firing

  Place place;
  int arcType;
  Expression expression;
  boolean trace;

  public Arc(Place place, int arcType, Expression expression) {
    if (arcType!=in && arcType!=test && arcType!=out && arcType!=both) {
      throw new RuntimeException("Bad arc type: "+arcType+".");
    }
    this.place=place;
    this.arcType=arcType;
    this.expression=expression;
    trace=true;
  }

  public void setTrace(boolean trace) {
    this.trace=trace;
  }

  public boolean getTrace() {
    return trace;
  }

  public boolean isTestArc() {
    return arcType==test || arcType==fastTest;
  }

  public InscriptionOccurrence makeOccurrence(VariableMapper mapper,
    NetInstance netInstance)
  {
    return new ArcOccurrence(this,mapper,netInstance);
  }
}

