package de.renew.simulator;

import collections.*;

public class Binding {
  private Seq executables;
  private String description;

  Binding(Searcher searcher) {
    executables=searcher.makeExecutables();
    StringBuffer descr=new StringBuffer();

    CollectionEnumeration occurrences=searcher.getOccurrences();
    while (occurrences.hasMoreElements()) {
      Occurrence occurrence=
	(Occurrence)occurrences.nextElement();
      descr.append(occurrence.toString());

      if (occurrences.hasMoreElements()) {
	descr.append(", ");
      }
    }
  
    description=descr.toString();
  }

  public boolean execute(final Tracer tracer, final boolean asynchronous) {
    if (executables==null) {
      throw new RuntimeException("Cannot execute binding twice.");
    }
    Seq exe=executables;
    executables=null;
    return SimulatorHelper.execute(exe,tracer,asynchronous);
  }

  public String toString() {
    return description;
  }
}
