package de.renew.simulator;

public class ConsoleTracer implements Tracer {
  String initialMessage;
  String prefix;

  public ConsoleTracer(String initialMessage, String prefix) {
    this.initialMessage=initialMessage;
    this.prefix=prefix;
  }

  public ConsoleTracer(String initialMessage) {
    this(initialMessage,"");
  }
  
  public ConsoleTracer() {
    this(null,"");
  }
  
  public void trace(String message) {
    if (initialMessage!=null) {
      System.out.println(prefix+initialMessage);
      initialMessage=null;
    }
    System.out.println(prefix+message);
  }

  public void complete() {
    // Nothing to do.
  }
}
