package de.renew.simulator;

import collections.*;
import de.renew.util.*;
import de.renew.unify.*;
import java.util.Vector;

class CreationOccurrence implements ExecutableOccurrence {
  Variable variable;
  Net net;
  NetInstance newNetInstance;

  CreationOccurrence(Variable variable, Net net) {
    this.variable=variable;
    this.net=net;
  }

  public CollectionEnumeration makeBinders(Searcher searcher)
    throws Impossible
  {
    // Create the new net instance.
    newNetInstance=net.makeInstance();

    // Assign it to the variable.
    Unify.unify(variable,newNetInstance,
      searcher.recorder); 

    // Nothing more to be done.
    return new EmptyEnumeration();
  }

  public CollectionEnumeration makeExecutables(Copier copier,
    VariableMapper mapper)
  {
    return new SingletonEnumeration(new CreationConfirmer(newNetInstance));
  }
}
