package de.renew.simulator;

import de.renew.unify.*;

public class InitialMarkingExpression implements InitialMarking {
  private Expression expression;
  private boolean trace;

  public InitialMarkingExpression(Expression expression) {
    this.expression=expression;
    trace=true;
  }

  public void setTrace(boolean trace) {
    this.trace=trace;
  }

  public boolean getTrace() {
    return trace;
  }

  public Object getInitialMarking() throws Impossible {
    Object value=expression.startEvaluation(
      new VariableMapper(),
      new StateRecorder(),
      null);
    if (!Unify.isBound(value)) {
      throw new Impossible();
    }
    return value;
  }
}
