package de.renew.simulator;

class InputTokenCollector implements TokenCollector {
  TokenReserver reserver;
  PlaceInstance instance;

  InputTokenCollector(TokenReserver reserver, PlaceInstance instance) {
    this.reserver=reserver;
    this.instance=instance;
  }

  // I return true, if the token is available now.
  // I make no guarantee about the future availability.
  public boolean containsToken(Object token) {
    return reserver.containsRemovableToken(instance,token);
  }
  
  // I return true, if I was successful in reserving the token.
  // If I return false, absolutely no change was made.
  public boolean collectToken(Object token) {
    return reserver.removeToken(instance,token);
  }

  // I free a previously reserved token.
  public void freeToken(Object token) {
    reserver.unremoveToken(instance,token);
  }

  // I start a registration.
  public void registerAt(Searcher searcher) {
    searcher.registerTrigger(instance.searchables());
  }
}
