package de.renew.simulator;

import collections.*;
import de.renew.unify.*;

public interface InscriptionOccurrence {
  // Prepare the binders that allow this inscription to act.
  // It is guaranteed that this method will be invoked only once.
  // 
  // If this method throws a Impossible, then there
  // cannot be a suitable binding. Possible bindings made using
  // the state recorder are not rolled back, this is left to 
  // the caller.
  CollectionEnumeration makeBinders(Searcher searcher)
    throws Impossible;
}
