package de.renew.simulator;

import de.renew.function.*;
import de.renew.unify.*;

public class NoArgExpression implements Expression {
  NoArgFunction function;

  public NoArgExpression(NoArgFunction function) {
    this.function=function;
  }

  public boolean isInvertible() {
    // Because there is only one value that this expression
    // can take, there is really no use in starting a search
    // process.
    return false;
  }

  public Object startEvaluation(VariableMapper mapper, StateRecorder recorder, 
    CalculationChecker checker) throws Impossible
  {
    return function.function();
  }

  public Object registerCalculation(VariableMapper mapper, 
    StateRecorder recorder, CalculationChecker checker) throws Impossible
  {
    return null;
  }
}
