package de.renew.simulator;

import collections.*;

class PlaceType {
  // This is the simplest possible place type:
  // it is not enumerable, or it cannot give
  // any hints on possible values.
  PlaceType() {}
  
  boolean isEnumerable() {
    return getValues()!=null;
  }

  int getValueCount() {
    if (getValues()==null) {
      return 0;
    } else {
      return getValues().numberOfRemainingElements();
    }
  }

  CollectionEnumeration getValues() {
    return null;
    // We are not enumerable. Subclasses will override.
  }
}
