package de.renew.simulator;

import collections.*;
import de.renew.unify.*;

class UntestArcExecutable implements LateExecutable {
  PlaceInstance placeInstance;
  Variable token;
  boolean trace;

  UntestArcExecutable(PlaceInstance placeInstance, Variable token,
    boolean trace)
  {
    this.placeInstance=placeInstance;
    this.token=token;
    this.trace=trace;
  }

  public long phase() {
    return 2L;
  }

  // We can untest a token quickly.
  public boolean isLong() {
    return false;
  }

  public void execute(Tracer tracer) {
    if (trace) {
      tracer.trace("    Untesting "+token.getValue()+
	" in "+placeInstance);
    }
    placeInstance.lock.lock();
    placeInstance.untestToken(token.getValue());
    placeInstance.lock.unlock();
  }
}
