package de.renew.unify;

import collections.*;

final class Unknown implements Referable {
  final private BacklinkSet backlinkSet=new BacklinkSet();
  final private RecorderChecker recorderChecker;

  Unknown() {
    recorderChecker=new RecorderChecker(null);
  }

  public boolean isComplete() {
    return false;
  }

  public boolean isBound() {
    return false;
  }

  public void addBacklink(Reference reference, StateRecorder recorder) {
    recorderChecker.checkRecorder(recorder);
    backlinkSet.addBacklink(reference,recorder);
  }

  // Moved here so that only an unknown needs to know about its
  // unification strategy.
  void unifySilently(Object that, StateRecorder recorder,
    UpdatableSet listeners) throws Impossible
  {
    // If the other object is unifiable too, we must
    // make an occurs check.
    if (that instanceof Referable) {
      ((Referable)that).occursCheck(this,new HashedSet());
    }

    // Make the update.
    backlinkSet.updateBacklinked(this,that,listeners,recorder);
  }

  public void occursCheck(Unknown that, UpdatableSet visited)
    throws Impossible
  {
    // Do I cause a cycle?
    if (this==that) {
      throw new Impossible();
    }
  }

  // Hide the normal equal and hashCode methods.
  // Because unknowns can change their values, it would
  // be desastrous to insert them into a hashtable.
  public boolean equal(Object that) {
    throw new RuntimeException(
      "Somebody compared an unknown.");
  }
  public int hashCode() {
    throw new RuntimeException(
      "Somebody took the hash code of an unknown.");
  }
}
