package de.renew.util;

import collections.*;

public class HashedRelation {
  private UpdatableMap hashtable;
  public HashedRelation() {
    hashtable=new HashedMap();
  }

  public synchronized void put(Object key, Object elem) {
    UpdatableSet set;
    if (hashtable.includesKey(key)) {
      set=(UpdatableSet)hashtable.at(key);
    } else {
      set=new HashedSet();
      hashtable.putAt(key,set);
    }
    set.include(elem);
  }

  public synchronized void remove(Object key, Object elem) {
    UpdatableSet set=(UpdatableSet)hashtable.at(key);
    set.exclude(elem);
    if (set.isEmpty()) {
      hashtable.removeAt(key);
    }
  }

  public synchronized CollectionEnumeration keys() {
    return hashtable.keys();
  }

  public synchronized CollectionEnumeration elementsAt(Object key) {
    if (hashtable.includesKey(key)) {
      UpdatableSet set=(UpdatableSet)hashtable.at(key);
      return set.elements();
    } else {
      return EmptyEnumeration.INSTANCE;
    }
  }

  public synchronized int sizeAt(Object key) {
    if (hashtable.includesKey(key)) {
      UpdatableSet set=(UpdatableSet)hashtable.at(key);
      return set.size();
    } else {
      return 0;
    }
  }
}
