package fs;

/**
 * The Identity class restricts the equality of objects
 * to their identity. Thereby two distinct, but equal
 * objects can be seperated, e.g. in a hashtable.
 */
class Identity {
  private Object o;
  Identity(Object o) {
    this.o=o;
  }
  public int hashCode() {
    return o.hashCode();
  }
  public boolean equals(Object id) {
    if (id instanceof Identity) {
      return o==((Identity)id).o;
    } else {
      return false;
    }
  }
  public Object getObject() {
    return o;
  }
}
