package fs;

import collections.*;
import java.util.*;

public class Partition {
   private UpdatableSet concepts = new HashedSet();

   public Partition() {}

   public Partition(ConceptImpl con) {
      concepts.include(con);
      con.partition = this;
   }

   public void addConcept(ConceptImpl newcon) throws TypeException {
      Enumeration concenum = concepts.elements();
      while (concenum.hasMoreElements()) {
         ConceptImpl con = (ConceptImpl)concenum.nextElement();
         if (con == newcon)
            return;
         if (con.isa(newcon) || newcon.isa(con))
            throw new TypeException();
      }
      concepts.include(newcon);
      newcon.partition.removeConcept(newcon);
      newcon.partition = this;
      System.out.println("Partition after add: "+this);
   }

   public void removeConcept(ConceptImpl con) {
      new Partition(con);
      concepts.removeOneOf(con);
   }

   public void remove() {
      Enumeration concenum = concepts.elements();
      while (concenum.hasMoreElements()) {
         ConceptImpl con = (ConceptImpl)concenum.nextElement();
         new Partition(con);
      }
   }

  public String toString() {
    StringBuffer output = new StringBuffer();
    CollectionEnumeration concs = concepts.elements();
    for (int i = 1; concs.hasMoreElements(); ++i) {
      if (i > 1)
	output.append(',');
      ConceptImpl con = (ConceptImpl)concs.nextElement();
      output.append(con.getName());
    }
      return output.toString();
  }

}
